#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
logfile="/var/log/userful-start.log"
CONFIG_FILE="/etc/multiuserdevices"
ProgramName=`basename $0`
source /opt/userful/bin/userful-bash-lib.sh
sleep 1
function sanity_check()
{
if [ ! -e /var/run/x.pid -o ! -d /proc/`cat /var/run/x.pid` ]; then
Print_Log "$ProgramName: MultiX is not running" $logfile
exit 1
fi
if  [ "$HAL_PROP_INFO_PARENT" == "" ] || \
[ "$HAL_PROP_INFO_CATEGORY" != "camera" ] || \
[ "$UDI" == "" ]; then
Print_Log "$ProgramName: Some HAL environment variables are missing." $logfile
exit 1
fi
}
if [ "$HALD_ACTION" == "add" ] ; then
sanity_check
device_file=`hal-get-property --udi "$HAL_PROP_INFO_PARENT" --key "linux.device_file"`
if [ "$device_file" == "" ]; then
Print_Log "$ProgramName: No linux.device_file for $HAL_PROP_INFO_PARENT" $logfile
exit 1
fi
USER_NAME="root"
CNT=1 # Wait for 3 seconds
while [ "$USER_NAME" == "root" ] && [ $CNT -le 3 ]
do
USER_NAME=`stat -c %U $device_file`
CNT=$((CNT+1))
sleep 1
done
if [ "$USER_NAME" == "root" ]; then
Print_Log "$ProgramName: Camera is not assigned to a user" $logfile
exit 1
fi
SCREEN_NUM=
if [ -f /opt/userful/locks/screen.$USER_NAME ]; then
SCREEN_NUM=`cat /opt/userful/locks/screen.$USER_NAME`
fi
if [ "$SCREEN_NUM" == "" ]; then
Print_Log "$ProgramName: No SCREEN_NUM for $USER_NAME" $logfile
exit 1
fi
Print_Log "$ProgramName: Camera device $device_file is assigned to $USER_NAME on :$SCREEN_NUM" $logfile
if which digikam > /dev/null; then
DISPLAY=:$SCREEN_NUM su -c \
"digikam --download-from-udi $UDI" $USER_NAME &
fi

elif [ "$HALD_ACTION" == "remove" ] ; then
:
else
Print_Log "$ProgramName: Unkown action: $HALD_ACTION" $logfile
fi
