#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
function check_arch()
{
case $(uname -m) in
x86_64|ia64)
echo "lib64"
;;
*)
echo "lib"
;;
esac
}
source /etc/sysconfig/xtype
source /etc/userful/os-info
if [ -f /tmp/distro.conf ]; then
source /tmp/distro.conf
fi
if [ -z "$DMPAM" ]; then
DMPAM=/etc/pam.d/gdm
fi
if [ -z "$XTYPE" -o "$XTYPE" == "SINGLE" ]; then
if [ "$OSNAME" != "novell" -o "$OSVER" != "10" ]; then
if [ -f /etc/dbus-1/system.d/hal.conf.multi-save ]; then 
mv -f /etc/dbus-1/system.d/hal.conf.multi-save /etc/dbus-1/system.d/hal.conf
fi
fi
#
if [ -f /etc/PolicyKit/PolicyKit.conf.multi-save ]; then 
mv -f /etc/PolicyKit/PolicyKit.conf.multi-save /etc/PolicyKit/PolicyKit.conf
fi
#
#
if [ -e $DMPAM ]; then
#
PAM_MODULE=""
PAM_MODULE=`grep "pam_console.so" $DMPAM`
if [ "$PAM_MODULE" != "" -a "${PAM_MODULE:0:1}" == "#" ]; then
NEW_PAM_MODULE=${PAM_MODULE:1}
sed -i -e "s/$PAM_MODULE/$NEW_PAM_MODULE/g" $DMPAM
fi
#
PAM_MODULE=""
PAM_MODULE=`grep "pam_devperm.so" $DMPAM`
if [ "$PAM_MODULE" != "" -a "${PAM_MODULE:0:1}" == "#" ]; then
NEW_PAM_MODULE=${PAM_MODULE:1}
sed -i -e "s/$PAM_MODULE/$NEW_PAM_MODULE/g" $DMPAM
fi
fi
echo "`date +"%b %d %T"` $ProgramName: Multi X is not enabled." >> $logfile
exit 0
fi
if [ -f /etc/dbus-1/system.d/hal.conf ]; then # FC 6, 8, 10
if [ ! -f /etc/dbus-1/system.d/hal.conf.multi-save ]; then
cp /etc/dbus-1/system.d/hal.conf /etc/dbus-1/system.d/hal.conf.multi-save
fi
if [ "$OSNAME" != "novell" -o "$OSVER" != "10" ]; then
if [[ -x /opt/userful/bin/umx-storage-update-hal-config.py ]]; then
/opt/userful/bin/umx-storage-update-hal-config.py /etc/dbus-1/system.d/hal.conf
chmod a+r /etc/dbus-1/system.d/hal.conf
dbus-send --system --type=method_call --dest=org.freedesktop.DBus / org.freedesktop.DBus.ReloadConfig
fi
fi
fi
if [[ -f /etc/PolicyKit/PolicyKit.conf ]]; then
if [[ ! -f /etc/PolicyKit/PolicyKit.conf.multi-save ]]; then
cp /etc/PolicyKit/PolicyKit.conf /etc/PolicyKit/PolicyKit.conf.multi-save
fi
if [[ -x /opt/userful/bin/umx-storage-update-polkit-config.py ]]; then
/opt/userful/bin/umx-storage-update-polkit-config.py /etc/PolicyKit/PolicyKit.conf
chmod a+r /etc/PolicyKit/PolicyKit.conf
fi
fi
#
LIB=$(check_arch)
#
if [ -f /usr/libexec/hal-storage-mount ]; then # FC6
ln -sf /opt/userful/bin/userful-storage-mount /usr/libexec/userful-storage-mount
ln -sf /opt/userful/bin/userful-storage-unmount /usr/libexec/userful-storage-unmount
ln -sf /opt/userful/bin/userful-storage-eject /usr/libexec/userful-storage-eject
elif [ -f /usr/$LIB/hal/hal-storage-mount ]; then # Kubuntu 7.04, Debian 4.0
ln -sf /opt/userful/bin/userful-storage-mount /usr/$LIB/hal/userful-storage-mount
ln -sf /opt/userful/bin/userful-storage-unmount /usr/$LIB/hal/userful-storage-unmount
ln -sf /opt/userful/bin/userful-storage-eject /usr/$LIB/hal/userful-storage-eject
elif [ -f /usr/$LIB/hal/scripts/hal-system-storage-mount ]; then # SLED10
ln -sf /opt/userful/bin/userful-storage-mount /usr/$LIB/hal/scripts/userful-storage-mount
ln -sf /opt/userful/bin/userful-storage-unmount /usr/$LIB/hal/scripts/userful-storage-unmount
ln -sf /opt/userful/bin/userful-storage-eject /usr/$LIB/hal/scripts/userful-storage-eject
fi
#
#
if [ -d /usr/$LIB/hal/scripts ]; then #
ln -sf /opt/userful/bin/multistation-storage-hotplug.sh /usr/$LIB/hal/scripts/multistation-storage-hotplug.sh
ln -sf /opt/userful/bin/multistation-camera-hotplug.sh /usr/$LIB/hal/scripts/multistation-camera-hotplug.sh
fi
#
if [ -e $DMPAM ]; then
PAM_MODULE=""
PAM_MODULE=`grep "pam_console.so" $DMPAM`
if [ "$PAM_MODULE" != "" -a "${PAM_MODULE:0:1}" != "#" ]; then
sed -i -e "s/$PAM_MODULE/#$PAM_MODULE/g" $DMPAM
fi
PAM_MODULE=""
PAM_MODULE=`grep "pam_devperm.so" $DMPAM`
if [ "$PAM_MODULE" != "" -a "${PAM_MODULE:0:1}" != "#" ]; then
sed -i -e "s/$PAM_MODULE/#$PAM_MODULE/g" $DMPAM
fi
fi
#
/opt/userful/bin/multistation-storage-refresh.sh
