#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
#
#
logfile="/var/log/userful-start.log"
CONFIG_FILE="/etc/multiuserdevices"
ProgramName=`basename $0`
SCREEN_NUM=$1
USER_NAME=$2

source /opt/userful/bin/userful-bash-lib.sh
sleep 1
function sanity_check()
{
if [ ! -e /var/run/x.pid -o ! -d /proc/`cat /var/run/x.pid` ]; then
Print_Log "$ProgramName: MultiX is not running" $logfile
exit 1
fi
if  [ "$HAL_PROP_BLOCK_DEVICE" == "" ] || \
[ "$HAL_PROP_INFO_CATEGORY" == "" ] || \
[ "$SCREEN_NUM" == "" ] || \
[ "$USER_NAME" == "" ] || \
[ "$HAL_PROP_BLOCK_IS_VOLUME" == "" ]; then
Print_Log "$ProgramName: Some HAL environment variables are missing." $logfile
exit 1
fi
}
if [ "$HALD_ACTION" == "add" ] ; then
sanity_check
USER_ID=`id -u "$USER_NAME"`
if [ -z "$USER_ID" ]; then
Print_Log "$ProgramName: Invalid User name: $USER_NAME" $logfile
exit 1
fi
VOLUME_UDI=
CNT=1  # Wait for 3 seconds
while [ "$VOLUME_UDI" == "" ] && [ $CNT -le 3 ]
do
if [ "$HAL_PROP_BLOCK_IS_VOLUME" == "true" ]; then
VOLUME_UDI=$UDI
else
VOLUME_UDI=`hal-find-by-property --key "info.parent" --string "$UDI"`
fi
CNT=$((CNT+1))
sleep 1
done

for D in $VOLUME_UDI
do
info_category=`hal-get-property --udi "$D" --key "info.category"`
if [ "$info_category" != "volume" ]; then
continue
fi
is_mounted=`hal-get-property --udi "$D" --key "volume.is_mounted"`
if [ "$is_mounted" == "true" ]; then
continue
fi
volume_fstype=`hal-get-property --udi "$D" --key "volume.fstype"`
block_device=`hal-get-property --udi "$D" --key "block.device"`
mount_point=`basename $block_device`
DEST="org.freedesktop.Hal"
MOUNT_METHOD="org.freedesktop.Hal.Device.Volume.Mount"
CMD=
case "$volume_fstype" in
"vfat")
CMD=$(printf "dbus-send --system --print-reply --dest=%s %s %s \
string:\"%s\" \
string:\"%s\" \
array:string:\"uid=%s\",\"utf8\",\"shortname=mixed\",\"flush\",\"umask=0077\"" \
"$DEST" "$D" "$MOUNT_METHOD" \
"$mount_point" \
"$volume_fstype" \
"$USER_ID")
;;
"ntfs-3g")
CMD=$(printf "dbus-send --system --print-reply --dest=%s %s %s \
string:\"%s\" \
string:\"%s\" \
array:string:\"uid=%s\",\"umask=0077\"" \
"$DEST" "$D" "$MOUNT_METHOD" \
"$mount_point" \
"$volume_fstype" \
"$USER_ID")
;;
"ext3"|"ext2")
CMD=$(printf "dbus-send --system --print-reply --dest=%s %s %s \
string:\"%s\" \
string:\"%s\" \
array:string:\"\"" \
"$DEST" "$D" "$MOUNT_METHOD" \
"$mount_point" \
"$volume_fstype")               
;;
*)
Print_Log "$ProgramName: Unsupported filesystem type: $volume_fstype" $logfile
;;
esac
if [ "$CMD" != "" ]; then
Print_Log "$ProgramName: Automount $block_device, filesystem:$volume_fstype" $logfile
su -c "$CMD" $USER_NAME
is_mounted=`hal-get-property --udi "$D" --key "volume.is_mounted"`
if [ "$is_mounted" == "true" ]; then
if [ "${volume_fstype//ext}" != "$volume_fstype" ]; then
chown $USER_NAME /media/$mount_point
chmod 700 /media/$mount_point
fi
if which dolphin > /dev/null; then
DISPLAY=:$SCREEN_NUM su -c \
"dolphin -icon system-file-manager -caption Dolphin /media/$mount_point" $USER_NAME &
fi
fi
fi
done
elif [ "$HALD_ACTION" == "remove" ] ; then
:
else
Print_Log "$ProgramName: Unkown action: $HALD_ACTION" $logfile
fi
